]> git.ipfire.org Git - thirdparty/git.git/blame - git-stash.sh
stash push: avoid printing errors
[thirdparty/git.git] / git-stash.sh
CommitLineData
f2c66ed1
NS
1#!/bin/sh
2# Copyright (c) 2007, Nanako Shiraishi
3
a5ab00c5
SB
4dashless=$(basename "$0" | sed -e 's/-/ /')
5USAGE="list [<options>]
fcdd0e92
SB
6 or: $dashless show [<stash>]
7 or: $dashless drop [-q|--quiet] [<stash>]
8 or: $dashless ( pop | apply ) [--index] [-q|--quiet] [<stash>]
a5ab00c5 9 or: $dashless branch <branchname> [<stash>]
1ada5020
TG
10 or: $dashless save [--patch] [-k|--[no-]keep-index] [-q|--quiet]
11 [-u|--include-untracked] [-a|--all] [<message>]
12 or: $dashless [push [--patch] [-k|--[no-]keep-index] [-q|--quiet]
13 [-u|--include-untracked] [-a|--all] [-m <message>]
14 [-- <pathspec>...]]
a5ab00c5 15 or: $dashless clear"
f2c66ed1 16
3cd2491a 17SUBDIRECTORY_OK=Yes
8f321a39 18OPTIONS_SPEC=
d0ea45bf 19START_DIR=$(pwd)
f2c66ed1
NS
20. git-sh-setup
21require_work_tree
22fc703e 22prefix=$(git rev-parse --show-prefix) || exit 1
ceff079b 23cd_to_toplevel
f2c66ed1
NS
24
25TMP="$GIT_DIR/.git-stash.$$"
c697b577 26TMPindex=${GIT_INDEX_FILE-"$(git rev-parse --git-path index)"}.stash.$$
3ba2e865 27trap 'rm -f "$TMP-"* "$TMPindex"' 0
f2c66ed1
NS
28
29ref_stash=refs/stash
30
dda1f2a5
TR
31if git config --get-colorbool color.interactive; then
32 help_color="$(git config --get-color color.interactive.help 'red bold')"
33 reset_color="$(git config --get-color '' reset)"
34else
35 help_color=
36 reset_color=
37fi
38
f2c66ed1 39no_changes () {
df6bba09
TG
40 git diff-index --quiet --cached HEAD --ignore-submodules -- "$@" &&
41 git diff-files --quiet --ignore-submodules -- "$@" &&
78751302
DC
42 (test -z "$untracked" || test -z "$(untracked_files)")
43}
44
45untracked_files () {
5fc92f88
KD
46 if test "$1" = "-z"
47 then
48 shift
49 z=-z
50 else
51 z=
52 fi
78751302
DC
53 excl_opt=--exclude-standard
54 test "$untracked" = "all" && excl_opt=
5fc92f88 55 git ls-files -o $z $excl_opt -- "$@"
f2c66ed1
NS
56}
57
58clear_stash () {
3023dc69
JH
59 if test $# != 0
60 then
b1440ce2 61 die "$(gettext "git stash clear with parameters is unimplemented")"
3023dc69 62 fi
1956dfa8 63 if current=$(git rev-parse --verify --quiet $ref_stash)
7ab3cc70 64 then
a9ee9bf9 65 git update-ref -d $ref_stash $current
7ab3cc70 66 fi
f2c66ed1
NS
67}
68
bc9e7399 69create_stash () {
9ca6326d
TG
70 stash_msg=
71 untracked=
72 while test $# != 0
73 do
74 case "$1" in
75 -m|--message)
76 shift
77 stash_msg=${1?"BUG: create_stash () -m requires an argument"}
78 ;;
79 -u|--include-untracked)
80 shift
81 untracked=${1?"BUG: create_stash () -u requires an argument"}
82 ;;
df6bba09
TG
83 --)
84 shift
85 break
86 ;;
9ca6326d
TG
87 esac
88 shift
89 done
9f62e18a 90
1eff26c0 91 git update-index -q --refresh
df6bba09 92 if no_changes "$@"
f2c66ed1 93 then
f2c66ed1
NS
94 exit 0
95 fi
f12e925a 96
f2c66ed1 97 # state of the base commit
5be60078 98 if b_commit=$(git rev-parse --verify HEAD)
f2c66ed1 99 then
b0e621ad 100 head=$(git rev-list --oneline -n 1 HEAD --)
f2c66ed1 101 else
b1440ce2 102 die "$(gettext "You do not have the initial commit yet")"
f2c66ed1
NS
103 fi
104
5be60078 105 if branch=$(git symbolic-ref -q HEAD)
f2c66ed1
NS
106 then
107 branch=${branch#refs/heads/}
108 else
109 branch='(no branch)'
110 fi
111 msg=$(printf '%s: %s' "$branch" "$head")
112
113 # state of the index
5be60078 114 i_tree=$(git write-tree) &&
6143fa2c 115 i_commit=$(printf 'index on %s\n' "$msg" |
5be60078 116 git commit-tree $i_tree -p $b_commit) ||
b1440ce2 117 die "$(gettext "Cannot save the current index state")"
f2c66ed1 118
78751302
DC
119 if test -n "$untracked"
120 then
121 # Untracked files are stored by themselves in a parentless commit, for
122 # ease of unpacking later.
123 u_commit=$(
5fc92f88 124 untracked_files -z "$@" | (
bed137d2
EP
125 GIT_INDEX_FILE="$TMPindex" &&
126 export GIT_INDEX_FILE &&
78751302
DC
127 rm -f "$TMPindex" &&
128 git update-index -z --add --remove --stdin &&
129 u_tree=$(git write-tree) &&
130 printf 'untracked files on %s\n' "$msg" | git commit-tree $u_tree &&
131 rm -f "$TMPindex"
850251f3 132 ) ) || die "$(gettext "Cannot save the untracked files")"
78751302
DC
133
134 untracked_commit_option="-p $u_commit";
135 else
136 untracked_commit_option=
137 fi
138
dda1f2a5
TR
139 if test -z "$patch_mode"
140 then
141
142 # state of the working tree
143 w_tree=$( (
3ba2e865
JS
144 git read-tree --index-output="$TMPindex" -m $i_tree &&
145 GIT_INDEX_FILE="$TMPindex" &&
dda1f2a5 146 export GIT_INDEX_FILE &&
df6bba09 147 git diff-index --name-only -z HEAD -- "$@" >"$TMP-stagenames" &&
44df2e29 148 git update-index -z --add --remove --stdin <"$TMP-stagenames" &&
dda1f2a5 149 git write-tree &&
3ba2e865 150 rm -f "$TMPindex"
dda1f2a5 151 ) ) ||
b1440ce2 152 die "$(gettext "Cannot save the current worktree state")"
dda1f2a5
TR
153
154 else
155
b24f56d6 156 rm -f "$TMP-index" &&
dda1f2a5
TR
157 GIT_INDEX_FILE="$TMP-index" git read-tree HEAD &&
158
159 # find out what the user wants
160 GIT_INDEX_FILE="$TMP-index" \
df6bba09 161 git add--interactive --patch=stash -- "$@" &&
dda1f2a5
TR
162
163 # state of the working tree
164 w_tree=$(GIT_INDEX_FILE="$TMP-index" git write-tree) ||
b1440ce2 165 die "$(gettext "Cannot save the current worktree state")"
f2c66ed1 166
44df2e29 167 git diff-tree -p HEAD $w_tree -- >"$TMP-patch" &&
dda1f2a5 168 test -s "$TMP-patch" ||
b1440ce2 169 die "$(gettext "No changes selected")"
dda1f2a5
TR
170
171 rm -f "$TMP-index" ||
b1440ce2 172 die "$(gettext "Cannot remove temporary index (can't happen)")"
dda1f2a5
TR
173
174 fi
175
f2c66ed1 176 # create the stash
9f62e18a
JH
177 if test -z "$stash_msg"
178 then
179 stash_msg=$(printf 'WIP on %s' "$msg")
180 else
181 stash_msg=$(printf 'On %s: %s' "$branch" "$stash_msg")
182 fi
183 w_commit=$(printf '%s\n' "$stash_msg" |
22f41286
JH
184 git commit-tree $w_tree -p $b_commit -p $i_commit $untracked_commit_option) ||
185 die "$(gettext "Cannot record working tree state")"
bc9e7399 186}
f2c66ed1 187
bd514cad
RR
188store_stash () {
189 while test $# != 0
190 do
191 case "$1" in
192 -m|--message)
193 shift
194 stash_msg="$1"
195 ;;
196 -q|--quiet)
197 quiet=t
198 ;;
199 *)
200 break
201 ;;
202 esac
203 shift
204 done
205 test $# = 1 ||
206 die "$(eval_gettext "\"$dashless store\" requires one <commit> argument")"
207
208 w_commit="$1"
209 if test -z "$stash_msg"
210 then
211 stash_msg="Created via \"git stash store\"."
212 fi
213
89dea973 214 git update-ref --create-reflog -m "$stash_msg" $ref_stash $w_commit
bd514cad 215 ret=$?
268ef4d3 216 test $ret != 0 && test -z "$quiet" &&
bd514cad
RR
217 die "$(eval_gettext "Cannot update \$ref_stash with \$w_commit")"
218 return $ret
219}
220
f5727e26 221push_stash () {
7bedebca 222 keep_index=
dda1f2a5 223 patch_mode=
78751302 224 untracked=
f5727e26 225 stash_msg=
fcdd0e92
SB
226 while test $# != 0
227 do
228 case "$1" in
ea41cfc4 229 -k|--keep-index)
fcdd0e92
SB
230 keep_index=t
231 ;;
dda1f2a5 232 --no-keep-index)
3a243f70 233 keep_index=n
dda1f2a5
TR
234 ;;
235 -p|--patch)
236 patch_mode=t
3a243f70
DM
237 # only default to keep if we don't already have an override
238 test -z "$keep_index" && keep_index=t
fcdd0e92
SB
239 ;;
240 -q|--quiet)
241 GIT_QUIET=t
242 ;;
78751302
DC
243 -u|--include-untracked)
244 untracked=untracked
245 ;;
246 -a|--all)
247 untracked=all
248 ;;
f5727e26
TG
249 -m|--message)
250 shift
251 test -z ${1+x} && usage
252 stash_msg=$1
253 ;;
5ba28313
JK
254 --help)
255 show_help
256 ;;
3c2eb80f
MM
257 --)
258 shift
259 break
260 ;;
261 -*)
eed10649
ÆAB
262 option="$1"
263 # TRANSLATORS: $option is an invalid option, like
264 # `--blah-blah'. The 7 spaces at the beginning of the
265 # second line correspond to "error: ". So you should line
266 # up the second line with however many characters the
267 # translation of "error: " takes in your language. E.g. in
268 # English this is:
269 #
270 # $ git stash save --blah-blah 2>&1 | head -n 2
271 # error: unknown option for 'stash save': --blah-blah
272 # To provide a message, use git stash save -- '--blah-blah'
ed3c400c
RL
273 eval_gettextln "error: unknown option for 'stash save': \$option
274 To provide a message, use git stash save -- '\$option'"
3c2eb80f
MM
275 usage
276 ;;
fcdd0e92
SB
277 *)
278 break
279 ;;
280 esac
7bedebca 281 shift
fcdd0e92 282 done
7bedebca 283
22fc703e
PS
284 eval "set $(git rev-parse --sq --prefix "$prefix" -- "$@")"
285
78751302
DC
286 if test -n "$patch_mode" && test -n "$untracked"
287 then
850251f3 288 die "$(gettext "Can't use --patch and --include-untracked or --all at the same time")"
78751302
DC
289 fi
290
df6bba09
TG
291 test -n "$untracked" || git ls-files --error-unmatch -- "$@" >/dev/null || exit 1
292
1eff26c0 293 git update-index -q --refresh
df6bba09 294 if no_changes "$@"
bc9e7399 295 then
5a175871 296 say "$(gettext "No local changes to save")"
bc9e7399
JH
297 exit 0
298 fi
df6bba09 299
89dea973 300 git reflog exists $ref_stash ||
b1440ce2 301 clear_stash || die "$(gettext "Cannot initialize stash")"
bc9e7399 302
df6bba09 303 create_stash -m "$stash_msg" -u "$untracked" -- "$@"
bd514cad
RR
304 store_stash -m "$stash_msg" -q $w_commit ||
305 die "$(gettext "Cannot save the current status")"
599e7a0b 306 say "$(eval_gettext "Saved working directory and index state \$stash_msg")"
7bedebca 307
dda1f2a5 308 if test -z "$patch_mode"
7bedebca 309 then
bbffd87d 310 test "$untracked" = "all" && CLEAN_X_OPTION=-x || CLEAN_X_OPTION=
833622a9 311 if test -n "$untracked" && test $# = 0
bbffd87d
NMC
312 then
313 git clean --force --quiet -d $CLEAN_X_OPTION -- "$@"
314 fi
315
df6bba09
TG
316 if test $# != 0
317 then
833622a9
TG
318 test -z "$untracked" && UPDATE_OPTION="-u" || UPDATE_OPTION=
319 test "$untracked" = "all" && FORCE_OPTION="--force" || FORCE_OPTION=
320 git add $UPDATE_OPTION $FORCE_OPTION -- "$@"
d97e4fa7
JH
321 git diff-index -p --cached --binary HEAD -- "$@" |
322 git apply --index -R
df6bba09 323 else
1790f4fe 324 git reset --hard -q
df6bba09 325 fi
dda1f2a5 326
268ef4d3 327 if test "$keep_index" = "t" && test -n "$i_tree"
dda1f2a5 328 then
e0e7f99e
TG
329 git read-tree --reset $i_tree
330 git ls-files -z --modified -- "$@" |
331 git checkout-index -z --force --stdin
dda1f2a5
TR
332 fi
333 else
334 git apply -R < "$TMP-patch" ||
b1440ce2 335 die "$(gettext "Cannot remove worktree changes")"
dda1f2a5 336
3a243f70 337 if test "$keep_index" != "t"
dda1f2a5 338 then
869fb8f7 339 git reset -q -- "$@"
dda1f2a5 340 fi
7bedebca 341 fi
f2c66ed1
NS
342}
343
f5727e26
TG
344save_stash () {
345 push_options=
346 while test $# != 0
347 do
348 case "$1" in
349 --)
350 shift
351 break
352 ;;
353 -*)
354 # pass all options through to push_stash
355 push_options="$push_options $1"
356 ;;
357 *)
358 break
359 ;;
360 esac
361 shift
362 done
363
364 stash_msg="$*"
365
366 if test -z "$stash_msg"
367 then
368 push_stash $push_options
369 else
370 push_stash $push_options -m "$stash_msg"
371 fi
372}
373
401de405 374have_stash () {
1956dfa8 375 git rev-parse --verify --quiet $ref_stash >/dev/null
401de405
JK
376}
377
f2c66ed1 378list_stash () {
401de405 379 have_stash || return 0
288c67ca 380 git log --format="%gd: %gs" -g --first-parent -m "$@" $ref_stash --
f2c66ed1
NS
381}
382
383show_stash () {
d6cc2df5 384 ALLOW_UNKNOWN_FLAGS=t
a9bf09e1 385 assert_stash_like "$@"
14cd4581 386
3086c064
NK
387 if test -z "$FLAGS"
388 then
389 if test "$(git config --bool stash.showStat || echo true)" = "true"
390 then
391 FLAGS=--stat
392 fi
393
394 if test "$(git config --bool stash.showPatch || echo false)" = "true"
395 then
396 FLAGS=${FLAGS}${FLAGS:+ }-p
397 fi
398
399 if test -z "$FLAGS"
400 then
401 return 0
402 fi
403 fi
404
405 git diff ${FLAGS} $b_commit $w_commit
f2c66ed1
NS
406}
407
5ba28313
JK
408show_help () {
409 exec git help stash
410 exit 1
411}
412
ef763129
JS
413#
414# Parses the remaining options looking for flags and
415# at most one revision defaulting to ${ref_stash}@{0}
416# if none found.
417#
418# Derives related tree and commit objects from the
419# revision, if one is found.
420#
421# stash records the work tree, and is a merge between the
422# base commit (first parent) and the index tree (second parent).
423#
424# REV is set to the symbolic version of the specified stash-like commit
425# IS_STASH_LIKE is non-blank if ${REV} looks like a stash
426# IS_STASH_REF is non-blank if the ${REV} looks like a stash ref
427# s is set to the SHA1 of the stash commit
428# w_commit is set to the commit containing the working tree
429# b_commit is set to the base commit
430# i_commit is set to the commit containing the index tree
78751302 431# u_commit is set to the commit containing the untracked files tree
ef763129
JS
432# w_tree is set to the working tree
433# b_tree is set to the base tree
434# i_tree is set to the index tree
78751302 435# u_tree is set to the untracked files tree
ef763129
JS
436#
437# GIT_QUIET is set to t if -q is specified
438# INDEX_OPTION is set to --index if --index is specified.
d6cc2df5 439# FLAGS is set to the remaining flags (if allowed)
ef763129
JS
440#
441# dies if:
442# * too many revisions specified
443# * no revision is specified and there is no stash stack
444# * a revision is specified which cannot be resolve to a SHA1
445# * a non-existent stash reference is specified
d6cc2df5 446# * unknown flags were set and ALLOW_UNKNOWN_FLAGS is not "t"
ef763129
JS
447#
448
449parse_flags_and_rev()
450{
451 test "$PARSE_CACHE" = "$*" && return 0 # optimisation
452 PARSE_CACHE="$*"
453
454 IS_STASH_LIKE=
455 IS_STASH_REF=
456 INDEX_OPTION=
457 s=
458 w_commit=
459 b_commit=
460 i_commit=
78751302 461 u_commit=
ef763129
JS
462 w_tree=
463 b_tree=
464 i_tree=
78751302 465 u_tree=
ef763129 466
ef763129 467 FLAGS=
a56c8f5a 468 REV=
2bea593b 469 for opt
ef763129 470 do
2bea593b
JS
471 case "$opt" in
472 -q|--quiet)
473 GIT_QUIET=-t
474 ;;
ef763129
JS
475 --index)
476 INDEX_OPTION=--index
477 ;;
5ba28313
JK
478 --help)
479 show_help
480 ;;
2bea593b 481 -*)
d6cc2df5
JK
482 test "$ALLOW_UNKNOWN_FLAGS" = t ||
483 die "$(eval_gettext "unknown option: \$opt")"
2bea593b 484 FLAGS="${FLAGS}${FLAGS:+ }$opt"
ef763129 485 ;;
a56c8f5a
AW
486 *)
487 REV="${REV}${REV:+ }'$opt'"
488 ;;
ef763129 489 esac
ef763129
JS
490 done
491
2a07e437 492 eval set -- $REV
ef763129
JS
493
494 case $# in
495 0)
e01db917 496 have_stash || die "$(gettext "No stash entries found.")"
ef763129
JS
497 set -- ${ref_stash}@{0}
498 ;;
499 1)
500 :
501 ;;
502 *)
33ceddcf 503 die "$(eval_gettext "Too many revisions specified: \$REV")"
ef763129
JS
504 ;;
505 esac
506
a56c8f5a
AW
507 case "$1" in
508 *[!0-9]*)
509 :
510 ;;
511 *)
512 set -- "${ref_stash}@{$1}"
513 ;;
514 esac
515
1956dfa8 516 REV=$(git rev-parse --symbolic --verify --quiet "$1") || {
155da748 517 reference="$1"
ad5fe377 518 die "$(eval_gettext "\$reference is not a valid reference")"
155da748 519 }
ef763129 520
1956dfa8 521 i_commit=$(git rev-parse --verify --quiet "$REV^2") &&
2a07e437 522 set -- $(git rev-parse "$REV" "$REV^1" "$REV:" "$REV^1:" "$REV^2:" 2>/dev/null) &&
ef763129
JS
523 s=$1 &&
524 w_commit=$1 &&
525 b_commit=$2 &&
526 w_tree=$3 &&
527 b_tree=$4 &&
528 i_tree=$5 &&
529 IS_STASH_LIKE=t &&
530 test "$ref_stash" = "$(git rev-parse --symbolic-full-name "${REV%@*}")" &&
531 IS_STASH_REF=t
78751302 532
1956dfa8 533 u_commit=$(git rev-parse --verify --quiet "$REV^3") &&
2a07e437 534 u_tree=$(git rev-parse "$REV^3:" 2>/dev/null)
ef763129
JS
535}
536
537is_stash_like()
538{
539 parse_flags_and_rev "$@"
540 test -n "$IS_STASH_LIKE"
541}
542
543assert_stash_like() {
777b6f13
ÆAB
544 is_stash_like "$@" || {
545 args="$*"
546 die "$(eval_gettext "'\$args' is not a stash-like commit")"
547 }
ef763129
JS
548}
549
550is_stash_ref() {
551 is_stash_like "$@" && test -n "$IS_STASH_REF"
552}
553
554assert_stash_ref() {
777b6f13
ÆAB
555 is_stash_ref "$@" || {
556 args="$*"
557 die "$(eval_gettext "'\$args' is not a stash reference")"
558 }
ef763129
JS
559}
560
f2c66ed1 561apply_stash () {
fcdd0e92 562
064ed100 563 assert_stash_like "$@"
f2c66ed1 564
b1440ce2 565 git update-index -q --refresh || die "$(gettext "unable to refresh index")"
5fd448f1
OA
566
567 # current index state
568 c_tree=$(git write-tree) ||
b1440ce2 569 die "$(gettext "Cannot apply a stash in the middle of a merge")"
5fd448f1 570
cbeaccc3 571 unstashed_index_tree=
064ed100 572 if test -n "$INDEX_OPTION" && test "$b_tree" != "$i_tree" &&
7bedebca 573 test "$c_tree" != "$i_tree"
cbeaccc3 574 then
89d750bf 575 git diff-tree --binary $s^2^..$s^2 | git apply --cached
150937c4 576 test $? -ne 0 &&
b1440ce2 577 die "$(gettext "Conflicts in index. Try without --index.")"
52070790 578 unstashed_index_tree=$(git write-tree) ||
b1440ce2 579 die "$(gettext "Could not save index tree")"
150937c4 580 git reset
cbeaccc3 581 fi
150937c4 582
78751302
DC
583 if test -n "$u_tree"
584 then
974ce807 585 GIT_INDEX_FILE="$TMPindex" git read-tree "$u_tree" &&
78751302
DC
586 GIT_INDEX_FILE="$TMPindex" git checkout-index --all &&
587 rm -f "$TMPindex" ||
e01db917 588 die "$(gettext "Could not restore untracked files from stash entry")"
78751302
DC
589 fi
590
f2c66ed1
NS
591 eval "
592 GITHEAD_$w_tree='Stashed changes' &&
593 GITHEAD_$c_tree='Updated upstream' &&
594 GITHEAD_$b_tree='Version stash was based on' &&
595 export GITHEAD_$w_tree GITHEAD_$c_tree GITHEAD_$b_tree
596 "
597
fcdd0e92
SB
598 if test -n "$GIT_QUIET"
599 then
69ae92bd 600 GIT_MERGE_VERBOSITY=0 && export GIT_MERGE_VERBOSITY
fcdd0e92 601 fi
52070790 602 if git merge-recursive $b_tree -- $c_tree $w_tree
f2c66ed1
NS
603 then
604 # No conflict
cbeaccc3
JH
605 if test -n "$unstashed_index_tree"
606 then
607 git read-tree "$unstashed_index_tree"
83b3df7d
JH
608 else
609 a="$TMP-added" &&
89d750bf 610 git diff-index --cached --name-only --diff-filter=A $c_tree >"$a" &&
83b3df7d
JH
611 git read-tree --reset $c_tree &&
612 git update-index --add --stdin <"$a" ||
b1440ce2 613 die "$(gettext "Cannot unstage modified files")"
83b3df7d 614 rm -f "$a"
cbeaccc3 615 fi
fcdd0e92
SB
616 squelch=
617 if test -n "$GIT_QUIET"
618 then
619 squelch='>/dev/null 2>&1'
620 fi
26b59b48 621 (cd "$START_DIR" && eval "git status $squelch") || :
f2c66ed1
NS
622 else
623 # Merge conflict; keep the exit status from merge-recursive
150937c4 624 status=$?
743bf6d8 625 git rerere
064ed100 626 if test -n "$INDEX_OPTION"
cbeaccc3 627 then
6fdd50e9 628 gettextln "Index was not unstashed." >&2
cbeaccc3 629 fi
150937c4 630 exit $status
f2c66ed1
NS
631 fi
632}
633
f276872d
JS
634pop_stash() {
635 assert_stash_ref "$@"
636
2d4c9933
JH
637 if apply_stash "$@"
638 then
639 drop_stash "$@"
640 else
641 status=$?
e01db917 642 say "$(gettext "The stash entry is kept in case you need it again.")"
2d4c9933
JH
643 exit $status
644 fi
f276872d
JS
645}
646
e25d5f9c 647drop_stash () {
92e39e44 648 assert_stash_ref "$@"
e25d5f9c 649
92e39e44 650 git reflog delete --updateref --rewrite "${REV}" &&
d4ca6c8b
ÆAB
651 say "$(eval_gettext "Dropped \${REV} (\$s)")" ||
652 die "$(eval_gettext "\${REV}: Could not drop stash entry")"
e25d5f9c
BC
653
654 # clear_stash if we just dropped the last stash entry
1956dfa8
DA
655 git rev-parse --verify --quiet "$ref_stash@{0}" >/dev/null ||
656 clear_stash
e25d5f9c
BC
657}
658
656b5034 659apply_to_branch () {
b1440ce2 660 test -n "$1" || die "$(gettext "No branch name specified")"
656b5034 661 branch=$1
fb433dc9 662 shift 1
656b5034 663
fb433dc9
JS
664 set -- --index "$@"
665 assert_stash_like "$@"
666
667 git checkout -b $branch $REV^ &&
57693d03
JS
668 apply_stash "$@" && {
669 test -z "$IS_STASH_REF" || drop_stash "$@"
670 }
656b5034
AMS
671}
672
9e140909
TG
673test "$1" = "-p" && set "push" "$@"
674
ef763129 675PARSE_CACHE='--not-parsed'
1ada5020 676# The default command is "push" if nothing but options are given
3c2eb80f
MM
677seen_non_option=
678for opt
679do
680 case "$opt" in
9e140909 681 --) break ;;
3c2eb80f
MM
682 -*) ;;
683 *) seen_non_option=t; break ;;
684 esac
685done
686
1ada5020 687test -n "$seen_non_option" || set "push" "$@"
3c2eb80f 688
f2c66ed1
NS
689# Main command set
690case "$1" in
fcb10a96
JH
691list)
692 shift
f2c66ed1
NS
693 list_stash "$@"
694 ;;
695show)
696 shift
697 show_stash "$@"
698 ;;
683befa1
KL
699save)
700 shift
47629dcf 701 save_stash "$@"
683befa1 702 ;;
f5727e26
TG
703push)
704 shift
705 push_stash "$@"
706 ;;
f2c66ed1
NS
707apply)
708 shift
709 apply_stash "$@"
710 ;;
711clear)
3023dc69
JH
712 shift
713 clear_stash "$@"
f2c66ed1 714 ;;
bc9e7399 715create)
0719f300 716 shift
9ca6326d 717 create_stash -m "$*" && echo "$w_commit"
bc9e7399 718 ;;
bd514cad
RR
719store)
720 shift
721 store_stash "$@"
722 ;;
e25d5f9c
BC
723drop)
724 shift
725 drop_stash "$@"
726 ;;
bd56ff54
BC
727pop)
728 shift
f276872d 729 pop_stash "$@"
bd56ff54 730 ;;
656b5034
AMS
731branch)
732 shift
733 apply_to_branch "$@"
734 ;;
f2c66ed1 735*)
3c2eb80f
MM
736 case $# in
737 0)
1ada5020 738 push_stash &&
5a175871 739 say "$(gettext "(To restore them type \"git stash apply\")")"
ea41cfc4
JS
740 ;;
741 *)
683befa1 742 usage
ea41cfc4 743 esac
9f62e18a 744 ;;
f2c66ed1 745esac